( function( )
{
	var _configuration = ExpressoLivre( ).JSON( );

	var _xconnector = null;
	var _xlink = null;

	function _go( )
	{
		_xconnector.go.apply( _xconnector, arguments );
	}

	function _link( )
	{
		_xlink.click.apply( _xlink, arguments );
	}

	function _path( )
	{
		return window.location.protocol + "//" + window.location.host + _configuration.url;
	}

	function _template( )
	{
		return _configuration.template;
	}

	function _theme( )
	{
		return _configuration.theme;
	}

	function _ExpressoLivre( )
	{
		return ( new function( )
		{
			this.go = _go;
			this.link = _link;
			this.path = _path;
			this.theme = _theme;
			this.template = _template;
		} );
	}

	window.ExpressoLivre = _ExpressoLivre( );

	_xlink = new XLink( ExpressoLivre.path( ) );

	_xconnector = new XConnector( {
		"path" : ExpressoLivre.path( ),
		"controller" : "?menuaction="
	} );

	XEvents.add( window, 'onload', function( )
	{
		document.getElementsByTagName( 'body' ).item( 0 ).style.overflowY = 'scroll';

		var _scripts = document.getElementsByTagName( 'head' ).item( 0 ).getElementsByTagName( 'script' );
		var _loaded = [ ];

		for ( var i = 0; i < _scripts.length; i++ )
			if ( _scripts.item( i ).getAttribute( 'src' ) != null )
				_loaded[ _loaded.length ] = _scripts.item( i ).getAttribute( 'src' ).substr(
					_path.length - 1,
					_scripts.item( i ).getAttribute( 'src' ).indexOf( '?' ) - _path.length + 1
				);

		new XScript( _loaded );

		var _links = document.getElementsByTagName( 'a' );
		for ( var i = 0; i < _links.length; i++ )
			_xlink.intercept( _links.item( i ) );
	} );
} )( );
